<template>
    <div v-click-outside="onClickOutside">
        <!-- Mobile menu -->
        <nav class="sm:hidden">
            <div class="flex gap-4 mx-auto items-center">
                <Logo />
                <ThemeToggler class="flex align-middle" />
                <!-- Toggle menu mobile icon (burger) -->
                <button aria-label="menu" class="mr-2 w-5 h-5 flex align-middle" @click="menu = !menu">
                    <font-awesome-icon :icon="menu ? 'times' : 'hamburger'" class="text-2xl" />
                </button>
            </div>
        </nav>
        <!-- Mobile nav list -->
        <nav v-show="menu" class="w-full">
            <ul class="flex flex-col text-center pt-6">
                <li v-if="isMobile" class="mb-3">
                    <AlgoliaSearch @results-closed="menu = false" />
                </li>
                <li v-for="(item, index) in items" :key="index">
                    <NuxtLink
                        :to="item.path"
                        class="p-5 block text-lg tracking-wide hover:bg-green-500"
                        @click.native="menuItemClicked"
                    >
                        {{ item.title }}
                    </NuxtLink>
                </li>
            </ul>
        </nav>
    </div>
</template>

<script>
import vClickOutside from 'v-click-outside'

export default {
    directives: {
        clickOutside: vClickOutside.directive,
    },
    props: {
        items: {
            type: Array,
            required: true,
        },
    },
    data() {
        return {
            menu: false,
            isMobile: false,
        }
    },
    mounted() {
        // Make vue-mobile-detection also work on server-side rendered page (dev)
        // https://stackoverflow.com/a/68123999/5982842
        this.isMobile = this.$isMobile()
    },
    methods: {
        onClickOutside() {
            this.menu = false
        },
        menuItemClicked() {
            // hide menu after some timeout to avoid hiding
            // it before navigating to new route
            setTimeout(() => (this.menu = false), 50)
        },
    },
}
</script>
